/*!
 * MIT License
 *
 * Copyright (c) 2020 Michael Marcenich
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
var WorkboxFirebaseAuth=function(){"use strict";const e=()=>new Promise(e=>{const t=firebase.auth().onAuthStateChanged(s=>{t(),s?s.getIdToken(!0).then(t=>{e(t)},()=>{e(null)}):e(null)})}),t=(e,t)=>{const s=new URL(e.url),i=!t.sameOrigin||self.location.origin===s.origin,r=((e,t)=>{const s=t&&t.split(",").map(e=>e.split(";")[0].trim());return!e||e.includes("*")||!s||s.some(t=>e.includes(t))})(t.types,e.headers.get("accept")),n=!t.https||"https:"===self.location.protocol||"localhost"===self.location.hostname,o=t.ignorePaths.length&&t.ignorePaths.some(e=>"string"==typeof e?s.pathname.startsWith(e):e.test(s.pathname));return i&&r&&n&&!o},s=(e,t)=>{const s=new Headers;e.headers.forEach((e,t)=>{s.append(t,e)}),s.append("Authorization","Bearer "+t);const{url:i,...r}=e.clone();return new Request(i,{...r,mode:"same-origin",redirect:"manual",headers:s})};return{initializeFirebase:e=>{const t={version:"7.14.2",...e};t.config?(importScripts(`https://www.gstatic.com/firebasejs/${t.version}/firebase-app.js`),importScripts(`https://www.gstatic.com/firebasejs/${t.version}/firebase-auth.js`),firebase.initializeApp(t.config)):(importScripts(`/__/firebase/${t.version}/firebase-app.js`),importScripts(`/__/firebase/${t.version}/firebase-auth.js`),importScripts("/__/firebase/init.js"))},Plugin:class{constructor(i={}){this.requestWillFetch=({request:i})=>new Promise(r=>{!this.awaitResponse&&t(i,this.constraints)?e().then(e=>{r(e?s(i,e):i)}).catch(e=>{console.error(e)}):r(i)}),this.fetchDidSucceed=({request:i,response:r})=>new Promise(n=>{this.awaitResponse&&401===r.status&&t(i,this.constraints)?e().then(e=>{if(!e)return void n(r);const t=s(i,e);fetch(t).then(e=>{n(e)})}).catch(e=>{console.error(e)}):n(r)}),this.awaitResponse=i.awaitResponse||!1;const{types:r,https:n,sameOrigin:o,ignorePaths:a}=i.constraints||{};this.constraints={types:"string"==typeof r?[r]:r||["*"],https:!!n,sameOrigin:"boolean"!=typeof o||o,ignorePaths:a||[]}}}}}();
